* PACKAGE DGENG  !" ϳ ڥȥ뢪ʻ
*
*  [HIS] 95/08/16 (takepiro) 
*        99/11/15 (takepiro) 
*
************************************************************************
      SUBROUTINE GENGD          !" ʻͤ
     O         ( GDU   , GDV   , GDW   , GDT   , 
     O           GDTOR , GDPOR ,
     I           WDTOR , WDPOR , WDT  , 
     C           FLAPLA, UVFACT,
     C           ARAD  , DRAD                    )
*
      IMPLICIT NONE
*
*   [PARAM]
#include        "zcdim.F"
*
*   [OUTPUT]
      REAL       GDU   ( IDIM*JDIM, KDIM )   !"   
      REAL       GDV   ( IDIM*JDIM, KDIM )   !"   
      REAL       GDW   ( IDIM*JDIM, KDIM )   !" ľ 
      REAL       GDT   ( IDIM*JDIM, KDIM )   !"   
      REAL       GDTOR ( IDIM*JDIM, KDIM )   !" ȥ 
      REAL       GDPOR ( IDIM*JDIM, KDIM )   !" ݥ 
*
*   [INPUT]
      REAL       WDTOR ( NMDIM , KDIM     )  !" ȥ 
      REAL       WDPOR ( NMDIM , KDIM     )  !" ݥ 
      REAL       WDT   ( NMDIM , KDIM     )  !"   
*
      REAL       FLAPLA( NMDIM  )            !" ץ饷η
      REAL       UVFACT( IDIM*JDIM )         !" uU Υե
      REAL       ARAD   ( KDIM )             !" ٥
      REAL       DRAD   ( KDIM )             !" 
*
*
*"         < 1.  ʻ >
*
      CALL W2G
     O         ( GDTOR ,
     I           WDTOR,
     I           '    ', 'POS', KDIM )
*
*"         < 2.  ʻ >
*
      CALL W2G
     O         ( GDPOR ,
     I           WDPOR,
     I           '    ', 'POS', KDIM )
*
*"         < 2.  ʻ >
*
      CALL W2G
     O         ( GDT   ,
     I           WDT   ,
     I           '    ', 'POSO', KDIM )
*
*"         < 3. , ,  γʻ >
*
      CALL POTVEL
     O         ( GDU   , GDV   , GDW   , 
     I           WDTOR , WDPOR , 
     C           FLAPLA, UVFACT        ,
     C           ARAD  , DRAD               )
*
      RETURN
      END
*
************************************************************************
      SUBROUTINE POTVEL          !" ®پη׻
     O         ( GDU   , GDV   , GDW   , 
     I           WDTOR , WDPOR , 
     C           FLAPLA, UVFACT        ,
     C           ARAD  , DRAD            )
*
      IMPLICIT NONE
*
*   [PARAM]
#include        "zcdim.F"
*
*   [OUTPUT]
      REAL       GDU   ( IDIM*JDIM, KDIM )   !"   u
      REAL       GDV   ( IDIM*JDIM, KDIM )   !"   v
      REAL       GDW   ( IDIM*JDIM, KDIM )   !" ľ w
*
*   [INPUT]
      REAL       WDTOR ( NMDIM , KDIM     )  !" ȥ 
      REAL       WDPOR ( NMDIM , KDIM     )  !" ݥ 
*
      REAL       FLAPLA( NMDIM  )            !" ץ饷η
      REAL       UVFACT( IDIM*JDIM )         !" uU Υե
      REAL       ARAD   ( KDIM )             !" ٥
      REAL       DRAD   ( KDIM )             !" 
*
*   [INTERNAL WORK]
      COMMON    /COMWRK/
     &           WDPHI , CDPOR
      REAL       CDPOR ( NMDIM , KDIM  )  !" ݥ 
      REAL       WDPHI ( NMDIM , KDIM  )  !" rD(r) ڥȥ(ľ)ʻ
*
      INTEGER    IJ, K, NM
*
*"         < 1.1 ȥݥƥ󥷥 >
*
*"         < 1.2  ݥݥƥ󥷥Σʬ >
*
      DO 3000 K = 1, KDIM
         DO 3000 NM = 1, NMDIM
            WDPHI ( NM, K ) = WDPOR ( NM, K ) / ARAD( K )
 3000 CONTINUE 
*
      CALL W2C
     M         ( CDPOR ,
     I           WDPOR ,
     I           ' '   , 'POS ', KDIM )
*
      CALL C2W
     M         ( WDPHI ,
     I           CDPOR ,
     I           'DR  ', 'ADD ', KDIM )
*
*"         < 2.   η׻ >
*
      CALL W2G
     O         ( GDU   ,
     I           WDTOR ,
     I           'YGRA', 'POS ', KDIM )
*
      IF ( MMAX .GE. 1 ) THEN
         CALL W2G
     O         ( GDU   ,
     I           WDPHI ,
     I           'XGRA', 'ADD ', KDIM )
      ENDIF
*
*"         < 3.  η׻ >
*
      CALL W2G
     O         ( GDV   ,
     I           WDPHI ,
     I           'YGRA', 'POS ', KDIM )
*
      IF ( MMAX .GE. 1 ) THEN
         CALL W2G
     O         ( GDV   ,
     I           WDTOR ,
     I           'XGRA', 'SUB ', KDIM )
      ENDIF
*
      DO 3100 K = 1, KDIM
         DO 3100 IJ = 1, IDIM*JDIM
            GDU ( IJ,K ) = GDU ( IJ,K ) / UVFACT( IJ )
            GDV ( IJ,K ) = GDV ( IJ,K ) / UVFACT( IJ )
 3100 CONTINUE
*
*"         < 4. w η׻ >
*
      DO 3200 K = 1, KDIM
         DO 3200 NM = 1, NMDIM
            WDPHI ( NM, K ) = - FLAPLA( NM ) * WDPOR( NM, K )
 3200 CONTINUE 
*
      CALL W2G
     O         ( GDW   ,
     I           WDPHI ,
     I           '    ', 'POS ', KDIM )
*
      DO 3300 K = 1, KDIM
         DO 3300 IJ = 1, IDIM*JDIM
            GDW ( IJ,K ) = GDW ( IJ,K ) / ARAD( K )
 3300 CONTINUE
*
      RETURN
      END
