* PACKAGE LSLFRQ  !" $B8GM-CM2r@O(B $B?6F0?tA*Br(B
*
*"  [HIS] 93/02/19(takepiro) 
*"        95/06/21(takepiro)  $B=PNO8GM-4X?t7W;;?tF3F~(B
*
**********************************************************************
      SUBROUTINE LSLFRQ
     M           (  GROWTH , FRQENC ,
     M              EIGVCR , EIGVCI ,
     O              NUMEIG ,
     I              NMKDIM , NVEC      )
*
      IMPLICIT NONE
*
*   [PARAM]
#include        "zcdim.F"                    !" $B3J;RE@?t(B, $BGH?t(B
#include        "zldim.F"                    !" $B%Q%i%a%?!<?t(B, $B78?t9TNs(B
*
*   [MODIFY]
      REAL       GROWTH( MATDMX )            !" $B@.D9N((B($B8GM-CM<B?tIt(B)
      REAL       FRQENC( MATDMX )            !" $B?6F0?t(B($B8GM-CM5u?tIt(B)
      REAL       EIGVCR( MATDMX, * )         !" $B8GM-%Y%/%H%k<B?tIt(B
      REAL       EIGVCI( MATDMX, * )         !" $B8GM-%Y%/%H%k5u?tIt(B
*
*   [OUTPUT]
      INTEGER    NUMEIG                      !" $B8GM-CM$N?t(B
*
*   [INPUT]
      INTEGER    NMKDIM                      !" $B78?t9TNs$N:GBgE:$(;z(B
      INTEGER    NVEC                        !" $B8GM-4X?t7W;;?t(B
*
*   [INTERNAL WORK]
      COMMON    /COMWRK/ WORK
      INTEGER    JORDER( MATDMX )            !" $BF~$l49$(=g=x(B
      REAL       WORK  ( MATDMX, MATDMX )    !" $BF~$l49$(MQ:n6HNN0h(B
      COMPLEX    ACS , ASN, EI
      DATA       EI/ ( 0.0, 1.0 )/
      INTEGER    I, J, JN, K
*
      JN = 0 
*
c$$$      DO 1000 J = 1, NMKDIM
      DO 1000 J = 1, NVEC
         IF ( FRQENC( J ) . NE. 0 ) THEN
            DO 1100 I = 2, NMKDIM, 2
               ACS = EIGVCR( I-1,J ) + EI * EIGVCI( I-1,J )
               ASN = - ( EIGVCR( I,J )   + EI * EIGVCI( I,J ) )
               IF( ABS( ACS ) .NE. 0 )THEN
                  IF ( IMAG ( ASN/ACS ) .GT. 0 )THEN
                     JN = JN + 1
                     JORDER( JN ) = J 
                  ENDIF
                  GOTO 1000
               ENDIF
 1100       CONTINUE 
         ELSE
            JN = JN + 1
            JORDER( JN ) = J
         ENDIF
 1000 CONTINUE 
*
      NUMEIG = JN
*
*"  < 2. $B8GM-CM(B, $B8GM-%Y%/%H%k$N%=!<%H(B ; $B8GM-CM5u?tIt"*?6F0?t(B>
*
      CALL COPY( WORK, GROWTH, NMKDIM )
      DO 2100 J = 1, NUMEIG
         GROWTH( J ) = WORK( JORDER(J),1  )
 2100 CONTINUE
*
      CALL COPY ( WORK, FRQENC , NMKDIM )
      DO 2200 J = 1, NUMEIG
         FRQENC( J ) = - WORK( JORDER(J),1  )
 2200 CONTINUE
*
      CALL COPY( WORK, EIGVCR, MATDMX*NVEC )
      DO 2300 K = 1, MIN( NUMEIG, NVEC )
         DO 2300 J = 1, NMKDIM
            EIGVCR( J,K ) = WORK( J,JORDER(K) )
 2300 CONTINUE
*
      CALL COPY( WORK, EIGVCI, MATDMX*NVEC )
      DO 2400 K = 1, MIN( NUMEIG, NVEC )
         DO 2400 J = 1, NMKDIM
            EIGVCI( J,K ) = WORK( J,JORDER(K) )
 2400 CONTINUE
*
      RETURN
      END
